package net.npaka.listviewex;
import java.util.List;
import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

//リスト配列アダプタ
public class ListArrayAdapter 
    extends ArrayAdapter<ListItem> {
    private List<ListItem> items;

    //コンストラクタ.
    public ListArrayAdapter(Context context,List<ListItem> items) {
        super(context,-1,items);
        this.items=items;
    }

    //セルのビューの生成(3)
    @Override
    public View getView(int position,
        View convertView,ViewGroup parent) {
        Context context=getContext();
        ListItem item=items.get(position);
        
        //レイアウトの生成
        if (convertView==null) {
            LinearLayout layout=new LinearLayout(context);
            layout.setPadding(10,10,10,10);
            layout.setBackgroundColor(Color.WHITE);
            convertView=layout;

            //アイコン
            ImageView imageView=new ImageView(context);
            imageView.setTag("icon");
            layout.addView(imageView);
        
            //テキストの指定
            TextView textView=new TextView(context);
            textView.setTag("text");
            textView.setText(item.text);
            textView.setTextColor(Color.rgb(0,0,0));
            //テキストビューのパディング指定(4)
            textView.setPadding(10,20,10,20);
            layout.addView(textView);
        }
        
        //値の指定
        ImageView imageView=
            (ImageView)convertView.findViewWithTag("icon");
        imageView.setImageBitmap(item.icon);
        TextView textView=
            (TextView)convertView.findViewWithTag("text");
        textView.setText(item.text);
        return convertView;
    }
}