package net.npaka.serviceex;
import java.util.List;

import android.app.Activity;
import android.app.ActivityManager;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;

//サービス
public class ServiceEx extends Activity     
    implements View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
        
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);         

        //再生ボタンの生成
        layout.addView(makeButton("プレーヤーサービスの開始","play"));
        layout.addView(makeButton("プレーヤーサービスの停止","stop"));
    }
 
    //ボタンの生成
    private Button makeButton(String text,String tag) {
        Button button=new Button(this);
        button.setTag(tag);
        button.setText(text);
        button.setOnClickListener(this); 
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        return button;        
    }  
    
    //ボタン押下時に呼ばれる
    public void onClick(View v) {
        String tag=(String)v.getTag();
        if (tag.equals("play")) {
            if (isServiceRunning(
                "net.npaka.serviceex.PlayerService")) return;
            
            //プレーヤーサービスの開始(1)
            Intent intent=new Intent(this,
                net.npaka.serviceex.PlayerService.class);
            startService(intent);
        } else if (tag.equals("stop")) {
            //プレーヤーサービスの停止(2)
            Intent intent=new Intent(this,
                net.npaka.serviceex.PlayerService.class);
            stopService(intent);
        }
    }
    
    //サービスが起動中かどうか(8)
    private boolean isServiceRunning(String className) {
        ActivityManager am=(ActivityManager)getSystemService(ACTIVITY_SERVICE);
        List<ActivityManager.RunningServiceInfo> serviceInfos=
            am.getRunningServices(Integer.MAX_VALUE);
        for (int i=0;i<serviceInfos.size();i++) {
            if (serviceInfos.get(i).service.getClassName().equals(className)) {
                return true;
            }
        }
        return false;
    }
}