package net.npaka.livefolderex;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.provider.LiveFolders;

//ライブフォルダの生成
public class LiveFolderEx extends Activity {
    //アクティビティ起動時に呼ばれる
    @Override
    protected void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        
        //インテントのアクションがACTION_CREATE_LIVE_FOLDERかどうかを判定(1)
        Intent intent=getIntent();
        String action=intent.getAction();        
        if (LiveFolders.ACTION_CREATE_LIVE_FOLDER.equals(action)) {
            setResult(RESULT_OK, createLiveFolder(this,
                "LiveFolderEx",                 //名前
                R.drawable.icon,                //アイコン
                LiveFolders.DISPLAY_MODE_LIST));//表示モード
        } else {
            setResult(RESULT_CANCELED);
        }
        finish();
    }
    
    //ライブフォルダの生成(2)
    private Intent createLiveFolder(
        Context context,String name,int icon,int displayMode) {
        Intent intent=new Intent();
        intent.setData(LiveFolderProvider.CONTACTS_URI);
        intent.putExtra(LiveFolders.EXTRA_LIVE_FOLDER_NAME,name);
        intent.putExtra(LiveFolders.EXTRA_LIVE_FOLDER_ICON,
            Intent.ShortcutIconResource.fromContext(context,icon));
        intent.putExtra(LiveFolders.EXTRA_LIVE_FOLDER_DISPLAY_MODE,
            displayMode);
        return intent;
    }
}
