package net.npaka.livefolderex;
import android.content.ContentProvider;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.MatrixCursor;
import android.net.Uri;
import android.provider.BaseColumns;
import android.provider.LiveFolders;

//ライブフォルダプロバイダ
public class LiveFolderProvider extends ContentProvider {
    //URL
    public static final String AUTHORITY="net.npaka.livefolderex.test";
    public static final Uri CONTACTS_URI=
        Uri.parse("content://"+AUTHORITY+"/test");
        
    //生成時に呼ばれる
    @Override
    public boolean onCreate() {
        return true;
    }

    //カーソルの列名(1)
    private static final String[] CURSOR_COLUMNS=new String[] {
        BaseColumns._ID,
        LiveFolders.NAME,
        LiveFolders.DESCRIPTION,
        LiveFolders.INTENT,
        LiveFolders.ICON_PACKAGE,
        LiveFolders.ICON_RESOURCE
    };
    
    //クエリー実行時に呼ばれる
    public Cursor query(Uri uri,String[] projection,String selection,
        String[] selectionArgs,String sortOrder) {
        //マトリックスカーソルの生成(1)
        MatrixCursor mc=new MatrixCursor(CURSOR_COLUMNS);
        
        //マトリックスカーソルへの行追加(2)
        mc.addRow(new Object[]{
            0,                            //ID
            "Webページの表示",               //名前
            "Webページを表示する",            //詳細
            Uri.parse("http://npaka.net/"),//インテント
            getContext().getPackageName(),//アイコンパッケージ
            R.drawable.icon               //アイコンリソース
        });
        mc.addRow(new Object[]{
            1,                            //ID
            "ダイアラーの表示",              //名前
            "ダイアラーを表示する",           //詳細
            Uri.parse("tel:117"),         //インテント
            getContext().getPackageName(),//アイコンパッケージ
            R.drawable.icon               //アイコンリソース
        });
        return mc;
    }

    //更新時に呼ばれる(未使用)
    @Override    
    public int update(Uri uri,ContentValues values,String selection,String[] selectionArgs) {
        return 0;
    }

    //挿入時に呼ばれる(未使用)
    @Override
    public Uri insert(Uri uri,ContentValues initialValues) {
        return null;
    }

    //削除時に呼ばれる(未使用)
    @Override
    public int delete(Uri uri,String selection,String[] selectionArgs) {
        return 0;
    }

    //種別の取得(未使用)
    @Override
    public String getType(Uri uri) {
        return null;
    }
}
