package net.npaka.mediarecorderex;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;

//音声合成
public class MediaRecorderEx extends Activity 
    implements View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //ボタンの生成
        layout.addView(makeButton("録音開始","audio"));
        layout.addView(makeButton("録画開始","video"));
    }
    
    //ボタンの生成
    private Button makeButton(String text,String tag) {
        Button button=new Button(this);
        button.setText(text);
        button.setTag(tag);
        button.setOnClickListener(this);
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        return button;
    }    
    
    //ボタンクリック時に呼ばれる
    public void onClick(View v) {
        String tag=(String)v.getTag();
        if (tag.equals("audio")) {
            Intent intent=new Intent(this,
                net.npaka.mediarecorderex.AudioActivity.class);
            startActivity(intent);
        } else if (tag.equals("video")) {
            Intent intent=new Intent(this,
                net.npaka.mediarecorderex.VideoActivity.class);
            startActivity(intent);
        } 
    }    
}