package net.npaka.twitterclient;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.util.Xml;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import oauth.signpost.OAuthProvider;
import oauth.signpost.basic.DefaultOAuthProvider;
import oauth.signpost.commonshttp.CommonsHttpOAuthConsumer;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.xmlpull.v1.XmlPullParser;

//Twitterクライアント
public class TwitterClient extends Activity {
    //定数
    private final static String 
        CONSUMER_KEY   ="コンシューマーキーを記述",
        CONSUMER_SECRET="コンシューマーシークレットを記述";
    private final String CALLBACKURL="myapp://mainactivity";
    private static final int 
        MENU_SETUP =0,
        MENU_UPDATE=1;

    //認証
    private CommonsHttpOAuthConsumer consumer;
    private OAuthProvider            provider;
    
    //情報
    private ListView listView;
    private static HashMap<String,Drawable> icons=
        new HashMap<String,Drawable>();
    private ArrayList<Status> timeline=
        new ArrayList<Status>();

    //アプリの初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        
        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //リストビューの生成(1)
        listView=new ListView(this);
        listView.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
        layout.addView(listView);
        
        //認証
        doOauth(false);
    }

    //オプションメニューの生成
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        MenuItem item0=menu.add(0,MENU_SETUP,0,"設定");
        item0.setIcon(android.R.drawable.ic_menu_add);
        MenuItem item1=menu.add(0,MENU_UPDATE,0,"更新");
        item1.setIcon(android.R.drawable.ic_menu_call);
        return true;
    }    

    //メニューアイテム選択イベントの処理
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        try {
            switch (item.getItemId()) {
            //設定
            case MENU_SETUP:
                doOauth(true);
                return true;
            //更新
            case MENU_UPDATE:
                updateTimeline();
                return true;
            }
        } catch (Exception e) {
        }
        return true;
    }
    
    //タイムラインの更新
    private void updateTimeline() {
        //ArrayList<Status> 
        timeline=new ArrayList<Status>();
        Status status =null;
        String tagName=null;
        InputStream in=null;
        try {
            //接続
            HttpGet httpGet=new HttpGet(
                "http://twitter.com/statuses/friends_timeline.xml"); 
            consumer.sign(httpGet);
            DefaultHttpClient http=new DefaultHttpClient();
            HttpResponse execute=http.execute(httpGet);
            
            //XMLのパース処理(4)
            in=execute.getEntity().getContent();
            final XmlPullParser parser=Xml.newPullParser();
            parser.setInput(new InputStreamReader(in));
            while (true) {
                int type=parser.next();
                //ドキュメント開始
                if (type==XmlPullParser.START_DOCUMENT) {
                } 
                //タグ開始
                else if (type==XmlPullParser.START_TAG) {
                    tagName=parser.getName();
                    if (tagName.equals("status")) {
                        status=new Status();
                        timeline.add(status);
                    }
                } 
                //テキスト
                else if (type==XmlPullParser.TEXT) {
                    if (parser.getText().trim().length()==0) {
                    } else if (tagName.equals("screen_name")) {
                        status.name=parser.getText();
                    } else if (tagName.equals("text")) {
                        status.text=parser.getText();
                    } else if (tagName.equals("profile_image_url")) {
                        status.iconURL=parser.getText();
                    }
                } 
                //タグ終了
                else if (type==XmlPullParser.END_TAG) {
                } 
                //ドキュメント終了
                else if (type==XmlPullParser.END_DOCUMENT) {
                    break;
                }                
            }

            //切断
            in.close();

            //更新
            for (int i=0;i<timeline.size();i++) {
                timeline.get(i).icon=readIcon(timeline.get(i).iconURL);
            }
            listView.setAdapter(new TwitterAdapter(this));
        } catch (Exception e) {
            Toast.makeText(this, e.getMessage(),Toast.LENGTH_LONG).show();
        }
    }
    
    //アイコンの読み込み
    private Drawable readIcon(String url) throws Exception {
        Drawable drawable=icons.get(url);
        if (drawable!=null) return drawable;
        byte[] data=http2data(url);
        Bitmap bmp=BitmapFactory.decodeByteArray(data,0,data.length);
        drawable=new BitmapDrawable(bmp);
        icons.put(url,drawable);
        return drawable;
    }

    //HTTP通信
    private byte[] http2data(String path) throws Exception {
        int size;
        byte[] w=new byte[1024]; 
        HttpURLConnection c=null;
        InputStream in=null;
        ByteArrayOutputStream out=null;
        try {
            //HTTP接続のオープン
            URL url=new URL(path);
            c=(HttpURLConnection)url.openConnection();
            c.setRequestMethod("GET");
            c.connect();
            in=c.getInputStream();
            
            //バイト配列の読み込み
            out=new ByteArrayOutputStream();
            while (true) {
                size=in.read(w);
                if (size<=0) break;
                out.write(w,0,size);
            }
            out.close();

            //HTTP接続のクローズ
            in.close();
            c.disconnect();
            return out.toByteArray();
        } catch (Exception e) {
            try {
                if (c!=null) c.disconnect();
                if (in!=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }
    
    //Twitterアダプタの生成(2)
    public class TwitterAdapter extends BaseAdapter {
        private Context context;

        //コンストラクタ
        public TwitterAdapter(Context c) {
            context=c;
        }

        //項目数の取得
        public int getCount() {
            return timeline.size();
        }

        //項目の取得
        public Object getItem(int position) {
            return timeline.get(position);
        }

        //項目IDの取得
        public long getItemId(int position) {
            return position;
        }

        //ビューの取得
        public View getView(int position,
            View convertView,ViewGroup parent) {
            TextView textView=new TextView(context);
            textView.setTextSize(12.0f);
            textView.setCompoundDrawablesWithIntrinsicBounds(
                timeline.get(position).icon,null,null,null);
            textView.setText("["+timeline.get(position).name+"]\n"+
                timeline.get(position).text);
            return textView;
        }
    }
    
    //OAuth認証による通信(3)
    private void doOauth(boolean setup) {
        try {
            consumer=new CommonsHttpOAuthConsumer(
                CONSUMER_KEY,CONSUMER_SECRET);
            provider=new DefaultOAuthProvider(
                "http://twitter.com/oauth/request_token",
                "http://twitter.com/oauth/access_token",
                "http://twitter.com/oauth/authorize");
            
            //トークンの読み込み
            SharedPreferences pref=getSharedPreferences(
                "token",MODE_PRIVATE);
            String token      =pref.getString("token","");
            String tokenSecret=pref.getString("tokenSecret","");
            
            //認証済み
            if (!setup && token.length()>0 && tokenSecret.length()>0) {
                consumer.setTokenWithSecret(token,tokenSecret);
                
                //Twitter操作
                updateTimeline();
            } 
            //認証処理のためブラウザ起動
            else {
                String url=provider.retrieveRequestToken(
                    consumer,CALLBACKURL);
                this.startActivity(
                    new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
            }
        } catch (Exception e) {
            Toast.makeText(this,e.getMessage(),Toast.LENGTH_LONG).show();
        }
    }
    
    //認証完了時に呼ばれる
    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        Uri uri=intent.getData();
        if (uri!=null && uri.toString().startsWith(CALLBACKURL)) {
            String verifier=uri.getQueryParameter(
                oauth.signpost.OAuth.OAUTH_VERIFIER);
            try {
                provider.retrieveAccessToken(consumer,verifier);

                //トークンの書き込み
                SharedPreferences pref=getSharedPreferences(
                    "token",MODE_PRIVATE);
                SharedPreferences.Editor editor=pref.edit();
                editor.putString("token",consumer.getToken());
                editor.putString("tokenSecret",consumer.getTokenSecret());
                editor.commit();

                //Twitter操作
                updateTimeline();
            } catch(Exception e){
                Toast.makeText(this, e.getMessage(),Toast.LENGTH_LONG).show();
            }
        }
    }
}