package net.npaka.xmllayoutex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;

//XMLによるレイアウト作成
public class XMLLayoutEx extends Activity 
    implements View.OnClickListener {
    private Button      button;     //ボタン
    private ImageButton imageButton;//イメージボタン

    //アクティビティ起動時に呼ばれる
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの指定(1)
        setContentView(R.layout.sample);       
        
        //コンポーネントの関連づけ(2)
        button=(Button)this.findViewById(R.id.button1);
        button.setOnClickListener(this);
        imageButton=(ImageButton)this.findViewById(
            R.id.imageButton1);
        imageButton.setOnClickListener(this);
    }   
    
    //ボタンクリックイベントの処理(2)
    public void onClick(View view) {
        //ボタンを押した時の処理
        if (view==button) {
            showDialog(this,"","ボタンを押した ");
        } 
        //イメージボタンを押した時の処理
        else if (view==imageButton) {
            showDialog(this,"","イメージボタンを押した ");
        }
    }
    
    //ダイアログの表示
    private static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }
}